//Definir pour microcontrleur

//Fonctions PIC
#pragma CLOCK_FREQ 4000000


//Dclarations de fonction Macro
void FCM_INTERRUPT_RB0INT();
void FCM_TEMPO();


//Dclarations de Variable
char FCV_CELL;
char FCV_CPT;
char FCV_OPEN;
char FCV_CLOSED;
char FCV_BP;

//Implmentations Macro

void FCM_INTERRUPT_RB0INT()
{
	if( FCV_CLOSED == 1 )
	{
		FCV_CLOSED =  0 ;
		set_bit(STATUS, RP0);
		TRISA = TRISA & 0xfc;
		clear_bit(STATUS, RP0);
		PORTA = PORTA & 0xfc | FCV_CLOSED;

		FCV_OPEN =  1 ;
		FCV_CPT =  19 ;
	}
}

void FCM_TEMPO()
{
	while(1)
	{
		set_bit(STATUS, RP0);
		TRISB = TRISB | 0x02;
		clear_bit(STATUS, RP0);
		FCV_BP = (PORTB & 0x02 == 0x02);

		if (!( FCV_BP == 0 )) break;
	}
	FCV_CPT =  0 ;
	while(1)
	{
		delay_ms(255);

		delay_ms(245);

		set_bit(STATUS, RP0);
		TRISB = TRISB | 0x02;
		clear_bit(STATUS, RP0);
		FCV_BP = (PORTB & 0x02 == 0x02);

		if( FCV_BP == 0 )
		{
			FCV_CLOSED =  0 ;
			goto FCC_TEMPO_A;
		}
		FCV_CPT =  FCV_CPT + 1 ;
		if (!( FCV_CPT < 20 )) break;
	}
FCC_TEMPO_A:
	FCV_CPT =  0 ;
}


void main()
{
//Initialisation PIC>

//Code d'initialisation d'Interruption
set_bit (STATUS, RP0);
OPTION_REG = 0xC0;
clear_bit (STATUS, RP0);

FCC_Principal_A:
	set_bit(STATUS, RP0);
	TRISB = TRISB | 0x02;
	clear_bit(STATUS, RP0);
	FCV_BP = (PORTB & 0x02 == 0x02);

	if( FCV_BP == 0 )
	{
	FCC_Principal_C:
		FCV_OPEN =  1 ;
		set_bit(STATUS, RP0);
		TRISA = TRISA & 0xfe;
		clear_bit(STATUS, RP0);
		if (FCV_OPEN)
			PORTA = PORTA & 0xfe | 0x01;
		else
			PORTA = PORTA & 0xfe;

		FCM_TEMPO();
	}
	else
	{
		goto FCC_Principal_A;
	}
	FCV_OPEN =  0 ;
	set_bit(STATUS, RP0);
	TRISA = TRISA & 0xfe;
	clear_bit(STATUS, RP0);
	if (0)
		PORTA = PORTA & 0xfe | 0x01;
	else
		PORTA = PORTA & 0xfe;

	while(1)
	{
		set_bit(STATUS, RP0);
		TRISB = TRISB | 0x02;
		clear_bit(STATUS, RP0);
		FCV_BP = (PORTB & 0x02 == 0x02);

		if (!( FCV_BP == 0 )) break;
	}
FCC_Principal_B:
	set_bit(STATUS, RP0);
	TRISB = TRISB | 0x01;
	clear_bit(STATUS, RP0);
	FCV_CELL = (PORTB & 0x01 == 0x01);

	set_bit(STATUS, RP0);
	TRISB = TRISB | 0x03;
	clear_bit(STATUS, RP0);
	FCV_BP = PORTB & 0x03;

	if( FCV_BP == 0 )
	{
		INTCON = INTCON & 0xEF | 0x90;
		FCV_CLOSED =  1 ;
		set_bit(STATUS, RP0);
		TRISA = TRISA & 0xfd;
		clear_bit(STATUS, RP0);
		if (FCV_CLOSED)
			PORTA = PORTA & 0xfd | 0x02;
		else
			PORTA = PORTA & 0xfd;

		delay_ms(255);

		delay_ms(145);

		set_bit(STATUS, RP0);
		TRISA = TRISA & 0xfe;
		clear_bit(STATUS, RP0);
		if (1)
			PORTA = PORTA & 0xfe | 0x01;
		else
			PORTA = PORTA & 0xfe;

		FCM_TEMPO();
		if( FCV_CLOSED == 0 )
		{
			set_bit(STATUS, RP0);
			TRISA = TRISA & 0xfc;
			clear_bit(STATUS, RP0);
			PORTA = PORTA & 0xfc | FCV_CLOSED;

			delay_ms(255);

			delay_ms(145);

			goto FCC_Principal_C;
		}
		FCV_CLOSED =  0 ;
		set_bit(STATUS, RP0);
		TRISA = TRISA & 0xfc;
		clear_bit(STATUS, RP0);
		PORTA = PORTA & 0xfc | FCV_CLOSED;

	}
	else
	{
		goto FCC_Principal_B;
	}
	goto FCC_Principal_A;
mainendloop: goto mainendloop;
}

void interrupt(void)
{
	if (INTCON & 2)
	{
		clear_bit(INTCON, 1);
		FCM_INTERRUPT_RB0INT();
	}
}
